"use strict";const fs=require("fs-extra"),util=require("util"),readFilePromise=util.promisify(fs.readFile),debug=require("debug")("Crittr Class"),log=require("signale"),chalk=require("chalk"),merge=require("deepmerge"),Queue=require("run-queue"),puppeteer=require("puppeteer"),devices=require("puppeteer/DeviceDescriptors"),mqpacker=require("css-mqpacker"),sortCSSmq=require("sort-css-media-queries"),CleanCSS=require("clean-css"),DEFAULTS=require("../Constants"),Ast=require("./Ast.class"),CssTransformator=require("./CssTransformator.class"),extractCriticalCss_script=require("../evaluation/extract_critical_with_css");class Crittr{constructor(e){this.options={css:null,urls:[],timeout:DEFAULTS.TIMEOUT,pageLoadTimeout:DEFAULTS.PAGE_LOAD_TIMEOUT,outputRemainingCss:DEFAULTS.OUTPUT_REMAINING_CSS,browser:{userAgent:DEFAULTS.BROWSER_USER_AGENT,isCacheEnabled:DEFAULTS.BROWSER_CACHE_ENABLED,isJsEnabled:DEFAULTS.BROWSER_JS_ENABLED,concurrentTabs:DEFAULTS.BROWSER_CONCURRENT_TABS},device:{width:DEFAULTS.DEVICE_WIDTH,height:DEFAULTS.DEVICE_HEIGHT,scaleFactor:DEFAULTS.DEVICE_SCALE_FACTOR,isMobile:DEFAULTS.DEVICE_IS_MOBILE,hasTouch:DEFAULTS.DEVICE_HAS_TOUCH,isLandscape:DEFAULTS.DEVICE_IS_LANDSCAPE},puppeteer:{browser:null,chromePath:null,headless:DEFAULTS.PUPPETEER_HEADLESS},printBrowserConsole:DEFAULTS.PRINT_BROWSER_CONSOLE,dropKeyframes:DEFAULTS.DROP_KEYFRAMES,keepSelectors:[],removeSelectors:[],blockRequests:["maps.gstatic.com","maps.googleapis.com","googletagmanager.com","google-analytics.com","google.","googleadservices.com","generaltracking.de","bing.com","doubleclick.net"]},this.options=merge(this.options,e),this._browser=null,this._cssTransformator=new CssTransformator,"string"==typeof this.options.device&&(devices[this.options.device]?this.options.device=devices[this.options.device].viewport:log.error("Option 'device' is set as string but has an unknown value. Use devices of puppeteer (https://github.com/GoogleChrome/puppeteer/blob/master/DeviceDescriptors.js) or an object!"));const t=this.validateOptions();if(t.length>0)throw t.forEach(({message:e})=>{log.error(e)}),new Error("crittr stopped working. See errors above.")}validateOptions(){const e=[];return Array.isArray(this.options.urls)||e.push({message:"Urls not an Array"}),Array.isArray(this.options.urls)&&0===this.options.urls.length&&(console.log("FEHLER"),e.push(new Error("NO URLs to check. Insert at least one url in the urls option!"))),"string"!=typeof this.options.css&&e.push({message:"css not valid. Expected string got "+typeof this.options.css}),e}run(){return new Promise(async(e,t)=>{debug("run - Starting run ...");let r="",s="",i=[];try{debug("run - Get css content ..."),this._cssContent=await this.getCssContent(),debug("run - Get css content done!")}catch(e){debug("run - ERROR while extracting css content"),t(e)}try{debug("run - Starting browser ..."),this._browser=await this.getBrowser(),debug("run - Browser started!")}catch(e){debug("run - ERROR: Browser could not be launched ... abort!"),t(e)}try{debug("run - Starting critical css extraction ..."),[r,s,i]=await this.getCriticalCssFromUrls(),i.length>0&&(log.warn("Some of the urls had errors. Please review them below!"),this.printErrors(i)),debug("run - Finished critical css extraction!")}catch(e){debug("run - ERROR while critical css extraction"),t(e)}try{debug("run - Browser closing ..."),await this._browser.close(),debug("run - Browser closed!")}catch(e){debug("run - ERROR: Browser could not be closed -> already closed?")}debug("run - Extraction ended!"),e({critical:r,rest:s})})}getBrowser(){return new Promise(async(e,t)=>{try{null!==this.options.puppeteer.browser&&e(this.options.puppeteer.browser),e(await puppeteer.launch({ignoreHTTPSErrors:!0,args:["--disable-setuid-sandbox","--no-sandbox","--ignore-certificate-errors","--disable-dev-shm-usage"],dumpio:!1,headless:this.options.puppeteer.headless,executablePath:this.options.puppeteer.chromePath}).then(e=>e))}catch(e){t(e)}})}gracefulClosePage(e,t){return new Promise(async(r,s)=>{this.printErrors(t);try{debug("gracefulClosePage - Closing page after error gracefully ..."),await e.close(),debug("gracefulClosePage - Page closed gracefully!")}catch(e){debug("gracefulClosePage - Error while closing page -> already closed?")}r()})}printErrors(e){if(e)if(log.warn(chalk.red("Errors occured during processing. Please have a look and report them if necessary")),Array.isArray(e))for(let t of e)log.error(t);else log.error(e)}getPage(){return this._browser.newPage()}getCssContent(){return new Promise(async(e,t)=>{if("string"==typeof this.options.css){let r="";if(this.options.css.endsWith(".css"))try{0===(r=await readFilePromise(this.options.css,"utf8")).length&&t(new Error("No CSS content in file exists -> exit!"))}catch(e){t(e)}else r=this.options.css;e(r)}else e(!1)})}getCriticalCssFromUrls(){return new Promise(async(e,t)=>{let r=[];const s=this.options.urls,i=new Set,o=new Set,a=this._cssTransformator.getAst(this._cssContent),l=new Queue({maxConcurrency:this.options.browser.concurrentTabs}),n=async(e,t,s,i)=>{try{debug("getCriticalCssFromUrls - Try to get critical ast from "+e);const[o,a]=await this.evaluateUrl(e,t);s.add(o),i.add(a),debug("getCriticalCssFromUrls - Successfully extracted critical ast!")}catch(t){debug("getCriticalCssFromUrls - ERROR getting critical ast from promise"),log.error("Could not get critical ast for url "+e),log.error(t),r.push(t)}};for(let e of s)l.add(1,n,[e,a,i,o]);l.run().then(async()=>{0===i.size&&t(r),debug("getCriticalCssFromUrls - Merging multiple atf ast objects. Size: "+i.size);let s=new Map;for(let e of i)try{s=Ast.generateRuleMap(e,s)}catch(e){debug("getCriticalCssFromUrls - ERROR merging multiple atf ast objects"),t(e)}debug("getCriticalCssFromUrls - Merging multiple atf ast objects - finished");let a=new Map;if(this.options.outputRemainingCss){debug("getCriticalCssFromUrls - Merging multiple rest ast objects. Size: "+o.size);for(let e of o)try{a=Ast.generateRuleMap(e,a)}catch(e){debug("getCriticalCssFromUrls - ERROR merging multiple rest ast objects"),t(e)}debug("getCriticalCssFromUrls - Merging multiple rest ast objects - finished"),debug("getCriticalCssFromUrls - Filter duplicates of restMap");for(const[e,t]of s)if(a.has(e)){let r=a.get(e);(r=r.filter(e=>!t.some(t=>e.hash===t.hash))).length>0?a.set(e,r):a.delete(e)}debug("getCriticalCssFromUrls - Filter duplicates of restMap - finished")}const l=new CleanCSS({compatibility:"*",properties:{backgroundClipMerging:!1,backgroundOriginMerging:!1,backgroundSizeMerging:!1,colors:!1,ieBangHack:!1,ieFilters:!1,iePrefixHack:!1,ieSuffixHack:!1,merging:!0,shorterLengthUnits:!1,spaceAfterClosingBrace:!0,urlQuotes:!0,zeroUnits:!1},selectors:{adjacentSpace:!1,ie7Hack:!0,mergeLimit:1e3,multiplePseudoMerging:!1},level:{1:{all:!1,cleanupCharsets:!0,removeWhitespace:!1},2:{mergeAdjacentRules:!0,mergeIntoShorthands:!1,mergeMedia:!0,mergeNonAdjacentRules:!0,mergeSemantically:!1,overrideProperties:!0,removeEmpty:!0,reduceNonAdjacentRules:!0,removeDuplicateFontRules:!0,removeDuplicateMediaBlocks:!0,removeDuplicateRules:!0,removeUnusedAtRules:!1,restructureRules:!1}}});debug("getCriticalCssFromUrls - Creating AST Object of atf ruleMap");let n=Ast.getAstOfRuleMap(s),c=this._cssTransformator.getCssFromAst(n);c=l.minify(c).styles,c=mqpacker.pack(c,{sort:sortCSSmq}).css;let u="";if(this.options.outputRemainingCss){debug("getCriticalCssFromUrls - Filter duplicates of restMap");for(const[e,t]of s)if(a.has(e)){let r=a.get(e);(r=r.filter(e=>!t.some(t=>e.hash===t.hash))).length>0?a.set(e,r):a.delete(e)}debug("getCriticalCssFromUrls - Filter duplicates of restMap - finished");let e=Ast.getAstOfRuleMap(a);u=this._cssTransformator.getCssFromAst(e),u=l.minify(u).styles,u=mqpacker.pack(u,{sort:sortCSSmq}).css}e([c,u,r])}).catch(e=>{t(e)})})}evaluateUrl(e,t){return new Promise(async(r,s)=>{let i=3,o=!1,a=null,l=new Map,n=null,c=null;const u=async()=>new Promise((e,t)=>{try{this.getPage().then(t=>{e(t)}).catch(r=>{i-- >0?(log.warn("Could not get page from browser. Retry "+i+" times."),e(u())):(log.warn("Tried to get page but failed. Abort now ..."),t(r))})}catch(e){t(e)}});try{debug("evaluateUrl - Open new Page-Tab ..."),a=await u(),!0===this.options.printBrowserConsole&&(a.on("console",e=>{const t=e.args();for(let e=0;e<t.length;++e)log.log(`${t[e]}`)}),a.on("pageerror",e=>{log.log("Page error: "+e.toString())}),a.on("error",e=>{log.log("Error: "+e.toString())})),debug("evaluateUrl - Page-Tab opened!")}catch(e){debug("evaluateUrl - Error while opening page tab -> abort!"),o=e}if(!1===o)try{let e=this.options.browser,t=this.options.device;debug("evaluateUrl - Set page properties ..."),await a.setCacheEnabled(e.isCacheEnabled),await a.setJavaScriptEnabled(e.isJsEnabled),await a.setRequestInterception(!0);const r=this.options.blockRequests;a.on("request",e=>{const t=e.url();if(r)for(const s of r)if(t.includes(s))return void e.abort();e.continue()}),a.on("error",e=>{o=e}),await a.emulate({viewport:{width:t.width,height:t.height,deviceScaleFactor:t.scaleFactor,isMobile:t.isMobile,hasTouch:t.hasTouch,isLandscape:t.isLandscape},userAgent:e.userAgent}),debug("evaluateUrl - Page properties set!")}catch(e){debug("evaluateUrl - Error while setting page properties -> abort!"),o=e}if(!1===o)try{debug("evaluateUrl - Navigating page to "+e),await a.goto(e,{timeout:this.options.timeout,waitUntil:["networkidle2"]}),debug("evaluateUrl - Page navigated")}catch(t){debug("evaluateUrl - Error while page.goto -> "+e),o=t}if(!1===o){try{debug("evaluateUrl - Extracting critical selectors"),await a.waitFor(250),l=new Map(await a.evaluate(extractCriticalCss_script,{sourceAst:t,loadTimeout:this.options.pageLoadTimeout,keepSelectors:this.options.keepSelectors,removeSelectors:this.options.removeSelectors,dropKeyframes:this.options.dropKeyframes})),debug("evaluateUrl - Extracting critical selectors - successful! Length: "+l.size)}catch(e){debug("evaluateUrl - Error while extracting critical selectors -> not good!"),o=e}debug("evaluateUrl - cleaning up AST with criticalSelectorMap");const[e,r]=this._cssTransformator.filterByMap(t,l);n=e,c=r,debug("evaluateUrl - cleaning up AST with criticalSelectorMap - END")}if(!1===o)try{debug("evaluateUrl - Closing page ..."),await a.close(),debug("evaluateUrl - Page closed")}catch(e){o=e,debug("evaluateUrl - Error while closing page -> already closed?")}if(!1!==o){try{await this.gracefulClosePage(a,o)}catch(e){}s(o)}r([n,c])})}}module.exports=Crittr;